# coding: utf-8

"""
    Hostinger API Python SDK

    API Version: 0.0.37

    NOTE: This file is auto-generated, DO NOT EDIT THIS FILE MANUALLY!
    If you want to contribute or request a new feature, please create an issue or pull request on https://github.com/hostinger/api
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class DomainsV1WHOISProfileResource(BaseModel):
    """
    DomainsV1WHOISProfileResource
    """ # noqa: E501
    id: Optional[StrictInt] = Field(default=None, description="WHOIS Profile ID")
    tld: Optional[StrictStr] = Field(default=None, description="TLD to which contact profile can be applied to")
    country: Optional[StrictStr] = Field(default=None, description="ISO 3166 2-letter country code")
    entity_type: Optional[StrictStr] = Field(default=None, description="WHOIS profile entity type")
    whois_details: Optional[Dict[str, Any]] = Field(default=None, description="WHOIS profile details")
    tld_details: Optional[Dict[str, Any]] = Field(default=None, description="TLD details")
    created_at: Optional[datetime] = None
    updated_at: Optional[datetime] = None
    __properties: ClassVar[List[str]] = ["id", "tld", "country", "entity_type", "whois_details", "tld_details", "created_at", "updated_at"]

    @field_validator('entity_type')
    def entity_type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['individual', 'organization']):
            raise ValueError("must be one of enum values ('individual', 'organization')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of DomainsV1WHOISProfileResource from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of DomainsV1WHOISProfileResource from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "tld": obj.get("tld"),
            "country": obj.get("country"),
            "entity_type": obj.get("entity_type"),
            "whois_details": obj.get("whois_details"),
            "tld_details": obj.get("tld_details"),
            "created_at": obj.get("created_at"),
            "updated_at": obj.get("updated_at")
        })
        return _obj


